
<template>
  <el-container style="height: 100%">
    <el-header>
      <commonheader></commonheader>
    </el-header>
    <el-container>
      <el-aside width="auto">
        <commonaside></commonaside>
      </el-aside>

      <el-main>
        <el-tabs v-model="activeName" >
          <el-tab-pane label="修改账户名" name="first" >
            <el-form :model="userlist" :rules="rules" ref="EditorUserForms">
                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-form-item label="原用户名  "  :label-width="formLabelWidth">
                      {{$store.state.userInfo.userName}}
                    </el-form-item>
                  </el-col>
                </el-row>

                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-form-item label="新用户名" prop="username" :label-width="formLabelWidth">
                      <el-input v-model="userlist.username" placeholder="请输入新用户名，不得与旧用户名相同">
                      </el-input>
                    </el-form-item>
                  </el-col>
                </el-row>

                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-button type="primary"  @click="EditorUserClick('userlist')" class="mydiv">提交</el-button>
                  </el-col>
                </el-row>
            </el-form>
          </el-tab-pane>

          <el-tab-pane label="修改昵称" name="second">
            <el-form :model="userlist" :rules="rules" ref="EditorNicknameForms">
                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-form-item label="原昵称"  :label-width="formLabelWidth">
                    {{$store.state.userInfo.userNickname}}
                  </el-form-item>
                  </el-col>
                </el-row>

                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-form-item label="新昵称" prop="nickname" :label-width="formLabelWidth">
                      <el-input v-model="userlist.nickname" placeholder="请输入新昵称，不得与旧用户名相同">
                      </el-input>
                    </el-form-item>
                  </el-col>
                </el-row>

                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-button type="primary"  @click="EditorNickNameClick('userlist')" class="mydiv">提交</el-button>
                  </el-col>
                </el-row>
            </el-form>

          </el-tab-pane>
          <el-tab-pane label="修改密码" name="third">
            <el-form :model="ruleForm" :rules="rules" ref="ruleForm">
                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-form-item label="新密码" prop="newpass" :label-width="formLabelWidth">
                      <el-input v-model="ruleForm.newpass" placeholder="请输入新密码" id="newkey" type="password">
                      </el-input>
                    </el-form-item>
                  </el-col>
                </el-row>

                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-form-item label="确认新密码" prop="checknewpass" :label-width="formLabelWidth">
                      <el-input v-model="ruleForm.checknewpass" placeholder="请确保两次输入新密码一致" id='newkey1' type="password">
                      </el-input>
                    </el-form-item>
                  </el-col>
                </el-row>

                <el-row type="flex" justify="center">
                  <el-col :span="8">
                    <el-button type="primary" @click="submitForm('ruleForm')" class="mydiv">提交</el-button>
                  </el-col>
                </el-row>
            </el-form>
          </el-tab-pane>
        </el-tabs>
      </el-main>
    </el-container>
  </el-container>
</template>
<script>
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import informationModification from '../services/informationModification'

export default {
  components: {
    commonaside,
    commonheader
  },
  name: 'informationModification',
  data () {
    var validatePass = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('请输入密码'))
      } else if (value.length < 6) {
        callback(new Error('密码长度至少为 6 位'))
      } else {
        if (this.ruleForm.checknewpass !== '') {
          this.$refs.ruleForm.validateField('checknewpass')
        }
        callback()
      }
    }
    var validatePass2 = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('请再次输入密码'))
      } else if (value !== this.ruleForm.newpass) {
        callback(new Error('两次输入密码不一致!'))
      } else {
        callback()
      }
    }

    return {
      ruleForm: {
        pass: '',
        newpass: '',
        checknewpass: ''
      }, // 修改密码的表单
      activeName: 'first',
      loading: true,
      userlist: {
        nickname: '',
        username: ''
      }, // 用户信息表单
      formLabelWidth: '200px',
      rules: {
        username: [
          {
            required: true,
            message: '请输入用户名'
          }
        ],
        nickname: [
          {
            required: true,
            message: '请输入昵称'
          }
        ],

        pass: [
          {
            required: true,
            trigger: 'blur',
            message: '请输入密码'
          }
        ],

        newpass: [
          {
            validator: validatePass,
            trigger: 'blur'
          }
        ],
        checknewpass: [
          {
            validator: validatePass2,
            trigger: 'blur'
          }
        ]
      }
    }
  },
  created () {
    if (this.$store.state.token === '') {
      this.$router.go(-1)
      this.$message({
        showClose: true,
        message: '用户尚未登陆,无法修改信息,请先登陆……',
        type: 'error'
      })
    }
  },

  methods: {
    async submitForm (formName) {
      var flag = 0
      this.$refs.ruleForm.validate(valid => {
        if (!valid) {
          this.$message({
            message: '请检查密码格式',
            type: 'error'
          })
        } else {
          flag = 1
        }
      })
      if (flag) {
        try {
          const response = await informationModification.postPassword({
            userId: this.$store.state.userInfo.userId,
            // newpassword: this.ruleForm.newpass,
            password: this.ruleForm.newpass
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
          if (response.data.code === 200 && response.data.data.status === 1) {
            await this.$alert('修改密码成功，请重新登录', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$store.commit('REMOVE_INFO')
                this.$router.push('/login')
              }
            })
          } else {
            this.error = response.data.msg
            await this.$alert(response.data.msg, '修改失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        } catch (error) {
          if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
            this.error = 'Network Error'
            await this.$alert('Network Error', '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          } else {
            this.error = error.response.data.error
          }
        }
      }
    },
    // 修改用户名
    async EditorUserClick (formName) {
      var flag = 0
      this.$refs.EditorUserForms.validate(valid => {
        if (!valid) {
          this.$message({
            message: '用户名不能为空',
            type: 'error'
          })
        } else {
          flag = 1
        }
      })
      if (flag) {
        try {
          const response = await informationModification.postName({
            name: this.userlist.username,
            userId: this.$store.state.userInfo.userId,
            et: 1
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
          if (response.data.code === 200 && response.data.data.status === 1) {
            this.$store.commit('SET_TOKEN', response.data.data.token)

            let user = this.$store.state.userInfo
            user.userName = response.data.data.newName
            user.token = response.data.data.token
            this.$store.commit('SET_USERINFO', user)

            await this.$alert('修改用户名成功', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.go(0)
              }
            })
          } else {
            this.error = response.data.msg
            await this.$alert(response.data.msg, '修改失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        } catch (error) {
          if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
            this.error = 'Network Error'
            await this.$alert('Network Error', '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          } else {
            if (error.response.data && error.response.data.msg) {
              await this.$alert(error.response.data.msg, '修改失败', {
                confirmButtonText: '确定',
                callback: action => {
                  this.$message({
                    type: 'info',
                    message: `action: ${action}`
                  })
                }
              })
            }
            this.error = error.response.data.error
          }
        }
      }
    }, // 修改昵称
    async EditorNickNameClick (formName) {
      var flag = 0
      this.$refs.EditorNicknameForms.validate(valid => {
        if (!valid) {
          this.$message({
            message: '昵称不能为空',
            type: 'error'
          })
        } else {
          flag = 1
        }
      })
      if (flag) {
        try {
          const response = await informationModification.postName({
            name: this.userlist.nickname,
            userId: this.$store.state.userInfo.userId,
            et: 0
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
          if (response.data.code === 200 && response.data.data.status === 1) {
            let user = this.$store.state.userInfo
            user.userNickname = this.userlist.nickname
            this.$store.commit('SET_USERINFO', user)

            await this.$alert('修改昵称成功', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.go(0)
              }
            })
            await this.$router.push('/')
          } else {
            this.error = response.data.msg
            await this.$alert(response.data.msg, '修改失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        } catch (error) {
          if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
            this.error = 'Network Error'
            await this.$alert('Network Error', '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          } else {
            this.error = error.response.data.error
          }
        }
      }
    }
  }
}
</script>
<style scoped>
.el-header {
    background-color: #333;
}
.el-main {
    padding-top: 0;
}
  .mydiv{
      margin-left: 200px;
  }
</style>
